package production_system;

import java.awt.event.*;
import javax.swing.*;
import well.java.LastHourProduction;
import field.java.*;
import java.awt.GridLayout;
import scenarioStructures.*;

//Button-panel that is contained in a ChooseProductionTargetFrame-object
public class ButtonPanel extends JPanel {

	private JLabel label_TimePeriod;
	private JLabel label_TimePeriodValue;
	private JLabel label_ScenarioChosen;
	private JLabel label_ScenarioChosenValue;
	private JButton button_GenerateFieldScenarios;
	private JButton button_ChooseScenario;
	private JButton button_WellSettings;
	private JButton button_Exit;
	private ButtonListener buttonListener;
	private ChooseProductionTargetFrame chooseProductionTarget;
	private int hours;
	private ProductionFrame production;
	
	public ButtonPanel(ChooseProductionTargetFrame chooseProductionTarget) {
		super();
		this.chooseProductionTarget = chooseProductionTarget;
		initializeComponent();//create the GUI
	}//end constructor
	
	//Create the GUI
	private void initializeComponent() {
		this.setLayout(new GridLayout(2,4) );
		
		label_TimePeriod = new JLabel("Hours validity: ");
		label_TimePeriodValue  = new JLabel();
		
		JPanel panel_TimePeriod = new JPanel();
		panel_TimePeriod.add(label_TimePeriod);
		panel_TimePeriod.add(label_TimePeriodValue);
		
		label_ScenarioChosen  = new JLabel("Scenario chosen: ");
		label_ScenarioChosenValue = new JLabel();
		
		JPanel panel_ScenarioChosen = new JPanel();
		panel_ScenarioChosen.add(label_ScenarioChosen);
		panel_ScenarioChosen.add(label_ScenarioChosenValue);
		
		button_GenerateFieldScenarios = new JButton("Generate field-scenarios");
		button_ChooseScenario = new JButton("Choose scenario");
		button_WellSettings = new JButton("Find well settings");
		button_Exit = new JButton("Exit");
		
		button_ChooseScenario.setEnabled(false);
		button_WellSettings.setEnabled(false);
		
		this.add(button_GenerateFieldScenarios);
		this.add(button_ChooseScenario);
		this.add(button_WellSettings);
		this.add(panel_TimePeriod);
		this.add(panel_ScenarioChosen);
		this.add(button_Exit);
		
		buttonListener = new ButtonListener();
		button_GenerateFieldScenarios.addActionListener(buttonListener);
		button_ChooseScenario.addActionListener(buttonListener);
		button_WellSettings.addActionListener(buttonListener);
		button_Exit.addActionListener(buttonListener);
	}
	
	//private class to create ActionListener
	private class ButtonListener implements ActionListener {
		
		public void actionPerformed(ActionEvent e) {
			if (e.getActionCommand( ).equals("Generate field-scenarios")) {
				String hoursValidity = JOptionPane.showInputDialog(null, "How many hours should the scenario be valid? Maximum 16 hours");
		        int int_hoursValidity = Integer.parseInt(hoursValidity);
				if(int_hoursValidity>1 && int_hoursValidity<17) { //the production time period is hardcoded to be between 1 to 16 hours.
					hours = Integer.parseInt(hoursValidity);
			        label_TimePeriodValue.setText(hoursValidity);
			        
			        //sending number of hours to the JFrame this button-panel belongs to, and
			        //getting the operatorAssistant-agent to wait for a scenario to be selected.
			        chooseProductionTarget.generateFieldScenarios(hours);
			        button_GenerateFieldScenarios.setEnabled(false);
			        button_ChooseScenario.setEnabled(true);
			        button_WellSettings.setEnabled(true);
				}
				else {
					JOptionPane.showMessageDialog(null, "Tast antall timer mellom 2-16");//the production time period is hardcoded to be between 1 to 16 hours.
				}//end if-else
			}
			else if(e.getActionCommand( ).equals("Choose scenario")) {
				String scenarioChosen = JOptionPane.showInputDialog(null, "Which scenario would you like to set as your production target?");
		        int scenario = Integer.parseInt(scenarioChosen);
		        
		        //the number of field-scenarios generated are hardcoded to be between 1 to 81.
		        if(scenario>0 && scenario<82) {
			        label_ScenarioChosenValue.setText(scenarioChosen);
			        chooseProductionTarget.setScenarioChosen(scenario);//tell the main GUI-window ChooseProductionTargetFrame-object which scenario that has been chosen.
			        button_GenerateFieldScenarios.setEnabled(false);
			        button_ChooseScenario.setEnabled(false);
			        production = new ProductionFrame(hours);//Creates the window ProductionFrame-object showing the actual production hour by hour
		        }
		        else {
		        	JOptionPane.showMessageDialog(null, "Tast et scenario mellom 1-81");
		        }//end if-else
			}
			else if(e.getActionCommand( ).equals("Find well settings")) {
				String scenarioChosen = JOptionPane.showInputDialog(null, "From which scenario would you like to the choke settings?");
		        int scenario = Integer.parseInt(scenarioChosen);
		        if(scenario>0 && scenario<82) {
			        Scenarios fieldScenarios = chooseProductionTarget.getFieldScenarios();
			        OneCompositeScenario oneFieldScenario = (OneCompositeScenario)fieldScenarios.getScenario(scenario-1);
			      //Creates the window ChokeSettingsFrame-object showing the well-settings for specified scenario, hour by hour.
			        ChokeSettingsFrame chokeSettings = new ChokeSettingsFrame(oneFieldScenario, hours);		        	
		        }
		        else {
		        	JOptionPane.showMessageDialog(null, "Tast et scenario mellom 1-81");
		        }//end if-else
			}
			else if(e.getActionCommand( ).equals("Exit")) {
				System.exit(0);
			}
			else {
				System.out.println("Failure while choosing production target.");
			}//end if-else
		}//end metode actionPerformed( )
	}//end class ButtonListener	
	
	public void setHourProduction(LastHourProduction lastHourProduction, boolean finished, int state) {
		production.addProduction(lastHourProduction, finished, state);
	}
	
}//end class ButtonPanel


