package production_system;

import java.awt.*;
import javax.swing.*;
import operatorAssistant.agent.*;
import field.java.*;
import well.java.*;
import scenarioStructures.*;

//Creates the main-window
public class ChooseProductionTargetFrame extends JFrame {

	private ButtonPanel panel_Buttons;
	private FieldScenariosFrame frame_FieldScenarios;
	private OperatorAssistant operatorAssistant;
	private int scenarioChosen;
	private ScenarioChosenObservable observable;
	private Scenarios fieldScenarios;

	public ChooseProductionTargetFrame() {
		super("Choice of production target");
		
		//create the GUI
		initializeComponent();
	}//end constructor

	//show GUI
	public void start() {
		this.setVisible(true);
	}//end start()
	
	//Create the GUI
	private void initializeComponent() {
		setSize(540, 100);
		setLocation(80, 100);
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setLayout(new FlowLayout( ));
		
		//creates all buttons in main-window
		panel_Buttons = new ButtonPanel(this);
		//creates a new window showing all generated scenarios
		frame_FieldScenarios = new FieldScenariosFrame();
		
		this.add(panel_Buttons);
		//object that observe if a scenario is chosen, and production shall start
		observable = new ScenarioChosenObservable();
	}//end initializeComponent()

	//getting hours-parameter from a ButtonPanel-object.
	//getting the operatorAssistant-agent to wait for a scenario to be selected.
	public void generateFieldScenarios(int hours) {
		frame_FieldScenarios.generateFieldScenarios(this, operatorAssistant, hours);
	}//end generateFieldScenarios()

	
	public Scenarios getFieldScenarios() {
		return fieldScenarios;
	}//end getFieldScenarios()
	
	public void showGeneratedFieldScenarios(Scenarios fieldScenarios) {
		this.fieldScenarios = fieldScenarios;
		frame_FieldScenarios.showGeneratedFieldScenarios(fieldScenarios);
	}//end showGeneratedFieldScenarios()
	
	public void setOperatorAssistant(OperatorAssistant operatorAssistant){
		this.operatorAssistant = operatorAssistant;
	}//end setOperatorAssistant()
	
	//get parameter from ButtonPanel-object with the number on the scenario that has been chosen.
	public void setScenarioChosen(int scenarioChosen) {
		this.scenarioChosen = scenarioChosen;
		//tell everyone listening to scenario-choice which one has been chosen.
		observable.setScenarioChosen(scenarioChosen);
	}//end setScenarioChosen()
	
	public int getScenarioChosen() {
		return scenarioChosen;
	}//end getScenarioChosen()
	
	
	public ScenarioChosenObservable getObservable() {
		return observable;
	}//end getObservable()
	
	public void setHourProudction(LastHourProduction lastHourProduction, boolean finished, int state) {
		panel_Buttons.setHourProduction(lastHourProduction, finished, state);
	}//end setHourProudction()
	
}//end class
