package production_system;

import java.awt.BorderLayout;
import java.awt.Dimension;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import well.java.*;

//Creates the window showing the actual production hour by hour
public class ProductionFrame extends JFrame {

	private JPanel panel_production;	
	private JTable table;
	private int nextIndex = 1;
	private int hoursValidity;
	private int totalOil = 0;
	private int totalGas = 0;
	private int totalWater = 0;
	private int totalSand = 0;
	private boolean proactivePlanningNotFollowed = false;
	
	public ProductionFrame(int hoursValidity) {
		super("Production logging");
	    this.hoursValidity = hoursValidity;
	    initializeComponent();
		showProduction(hoursValidity);		
	}//end constructor

	private void initializeComponent() {
	    setSize(500, 300);
	    setLocation(540, 100);
	    panel_production = new JPanel();
	}
	
	public void addProduction(LastHourProduction lastHourProduction, boolean finished, int state) {
		Integer oil = (Integer)lastHourProduction.get(0);
		Integer gas = (Integer)lastHourProduction.get(1);
		Integer water = (Integer)lastHourProduction.get(2);
		Integer sand = (Integer)lastHourProduction.get(3);
		
		table.setValueAt(oil, 0, nextIndex);
		table.setValueAt(gas, 1, nextIndex);
		table.setValueAt(water, 2, nextIndex);
		table.setValueAt(sand, 3, nextIndex);
		
		totalOil = totalOil + oil.intValue();
		totalGas = totalGas + gas.intValue();
		totalWater = totalWater + water.intValue();
		totalSand = totalSand + sand.intValue();

		//System.out.println("finished: "+finished);
		
		if(state==2) {
			proactivePlanningNotFollowed = true;
			//System.out.println("REACTIVE");
		}
		
		if(finished==true && nextIndex<hoursValidity && proactivePlanningNotFollowed==true) {
			//System.out.println("FERDIG 1");
			//JOptionPane.showMessageDialog(null, "Scenarioet ble ikke fulgt til produksjonsmlet ble oppndd. \nProduksjonsml ble ndd fr tidsperioden ble ferdig. \nProduksjonen ble som flgende - Total oil: "+totalOil+", total gas: "+totalGas+", total water: "+totalWater+", total sand: "+totalSand+", average OilWaste-ratio: "+((double)totalOil/(double)(totalGas+totalWater+totalSand) ) );
			JOptionPane.showMessageDialog(null, "The field production-scenario was not followed during the whole period of time chosen. \nThe oil production target chosen was reached before the period of time was finished. \nThe total amount of production is - Total oil: "+totalOil+", total gas: "+totalGas+", total water: "+totalWater+", total sand: "+totalSand+", average OilWaste-ratio: "+((double)totalOil/(double)(totalGas+totalWater+totalSand) ) );
		}
		else if(finished==true && nextIndex<hoursValidity && proactivePlanningNotFollowed==false) {
			//System.out.println("FERDIG 2");
			//JOptionPane.showMessageDialog(null, "Scenarioet ble fulgt til produksjonsmlet ble oppndd. \nProduksjonsml ble ndd fr tidsperioden ble ferdig. \nProduksjonen ble som flgende - Total oil: "+totalOil+", total gas: "+totalGas+", total water: "+totalWater+", total sand: "+totalSand+", average OilWaste-ratio: "+((double)totalOil/(double)(totalGas+totalWater+totalSand) ) );
			JOptionPane.showMessageDialog(null, "The field production-scenario was followed during the whole period of time chosen. \nThe oil production target chosen was reached before the period of time was finished. \nThe total amount of production is - Total oil: "+totalOil+", total gas: "+totalGas+", total water: "+totalWater+", total sand: "+totalSand+", average OilWaste-ratio: "+((double)totalOil/(double)(totalGas+totalWater+totalSand) ) );
		}
		else if(finished==true && nextIndex==hoursValidity && proactivePlanningNotFollowed==true) {
			//System.out.println("FERDIG 3");
			//JOptionPane.showMessageDialog(null, "Scenarioet ble ikke fulgt til produksjonsmlet ble oppndd. \nProduksjonsml ble ndd nr tidsperioden ble avsluttet. \nProduksjonen ble som flgende - Total oil: "+totalOil+", total gas: "+totalGas+", total water: "+totalWater+", total sand: "+totalSand+", average OilWaste-ratio: "+((double)totalOil/(double)(totalGas+totalWater+totalSand) ) );			
			JOptionPane.showMessageDialog(null, "The field production-scenario was not followed the whole time until the oil production target was reached. \nThe oil production target chosen was reached when the period of time was finished. \nThe total amount of production is - Total oil: "+totalOil+", total gas: "+totalGas+", total water: "+totalWater+", total sand: "+totalSand+", average OilWaste-ratio: "+((double)totalOil/(double)(totalGas+totalWater+totalSand) ) );			
		}
		else if(finished==false && nextIndex==hoursValidity && proactivePlanningNotFollowed==true) {
			//System.out.println("FERDIG 4");
			//JOptionPane.showMessageDialog(null, "Scenarioet ble ikke fulgt til produksjonsmlet ble oppndd. \nProduksjonsml ble ikke ndd fr tidsperioden ble avsluttet. \nProduksjonen ble som flgende - Total oil: "+totalOil+", total gas: "+totalGas+", total water: "+totalWater+", total sand: "+totalSand+", average OilWaste-ratio: "+((double)totalOil/(double)(totalGas+totalWater+totalSand) ) );			
			JOptionPane.showMessageDialog(null, "The field production-scenario was not followed during the whole period of time chosen. \nThe oil production target chosen was not reached when the period of time was finished. \nThe total amount of production is - Total oil: "+totalOil+", total gas: "+totalGas+", total water: "+totalWater+", total sand: "+totalSand+", average OilWaste-ratio: "+((double)totalOil/(double)(totalGas+totalWater+totalSand) ) );			
		}
		else if(finished==true && nextIndex==hoursValidity && proactivePlanningNotFollowed==false) {
			//System.out.println("FERDIG 5");
			//JOptionPane.showMessageDialog(null, "Scenarioet ble fulgt hele tidsperioden. \nProduksjonsml ble ndd nr tidsperioden ble avsluttet. \nProduksjonen ble som flgende - Total oil: "+totalOil+", total gas: "+totalGas+", total water: "+totalWater+", total sand: "+totalSand+", average OilWaste-ratio: "+((double)totalOil/(double)(totalGas+totalWater+totalSand) ) );			
			JOptionPane.showMessageDialog(null, "The field production-scenario was followed during the whole period of time chosen. \nThe oil production target chosen was reached when the period of time was finished. \nThe total amount of production is - Total oil: "+totalOil+", total gas: "+totalGas+", total water: "+totalWater+", total sand: "+totalSand+", average OilWaste-ratio: "+((double)totalOil/(double)(totalGas+totalWater+totalSand) ) );			
		}//end if-else
		
		nextIndex++;
	}//end addProduction()

	public void showProduction(int hoursValidity) {
	    Object[][] rows = new Object[4][hoursValidity+1];
		
	    rows[0][0] = "Oil";
	    rows[1][0] = "Gas";
	    rows[2][0] = "Water";
	    rows[3][0] = "Sand";
	    		
	    /* Specify column names */
	    String columns[] = new String[hoursValidity+1];  
	    columns[0]="Well id";
	    
	    for(int i=1;i<=hoursValidity;i++){
	    	columns[i] = "Hour "+String.valueOf(i);
	    }//end for-loop
	    
	    table = new JTable(rows, columns );
	    JScrollPane pane = new JScrollPane(table);
	    Dimension dim = new Dimension(500, 300);
	    pane.setPreferredSize(dim);
	    panel_production.add(pane);
	    this.add(panel_production, BorderLayout.CENTER);
	    this.setVisible(true);	
	}//end showGeneratedFieldScenarios()
	
}//end class
