/*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
  This code is generated by JAC version 5.3 by
  Agent Oriented Software. http://www.agent-software.com.au

    DO NOT ALTER THIS CODE AND DO NOT REMOVE THIS COMMENT
 *=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*/
package subseaTemplate.plan;
import aos.jack.jak.plan.Plan;
import aos.jack.jak.plan.PlanFSM;
import aos.jack.jak.plan.ExMap;
import aos.jack.jak.agent.NameSpace;
import aos.jack.jak.event.Event;
import aos.jack.jak.task.Task;
import aos.jack.jak.core.Generator;
import aos.jack.jak.logic.Signature;
import systemEvents.GenerateScenarios;
import systemEvents.ScenariosGenerated;
import subseaTemplate.agent.SubseaTemplate;
import java.util.ArrayList;
import scenarioStructures.Scenarios;
import scenarioStructures.OneCompositeScenario;
import java.lang.Object;
import aos.jack.jak.cursor.Cursor;
import aos.jack.jak.fsm.FSM;
import scenarioStructures.OneWellScenario;
import aos.jack.jak.core.Jak;

/**
 * FindSubseaTemplateScenarios
 */

public class FindSubseaTemplateScenarios extends aos.jack.jak.plan.Plan {
    private scenarioStructures.Scenarios subseaTemplateScenarios;
    private int hoursValidity = 0;
    private java.util.ArrayList connectedWells;
    private java.util.ArrayList generatedWellScenarios;
    public systemEvents.GenerateScenarios ev;
    public systemEvents.ScenariosGenerated ev1;
    public systemEvents.GenerateScenarios ev2;
    public subseaTemplate.agent.SubseaTemplate self;
    private static aos.jack.jak.plan.ExMap[] __exMap_body;
    private static java.lang.String[] __tt__body = {
            "subseaTemplate/plan/FindSubseaTemplateScenarios.plan",
            "body",
            "42",
            "43",
            "44",
            "47",
            "47",
            "48",
            "49",
            "50",
            "51",
            "52",
            "53",
            "47",
            "56",
            "57",
            "58",
            "39"};
    private final static java.lang.String[] __planVariableNames = {
            "subseaTemplateScenarios",
            "hoursValidity",
            "connectedWells",
            "generatedWellScenarios",
            "ev",
            "ev1",
            "ev2",
            "self"};
    private final static java.lang.String[] __planVariableTypes = {
            "Scenarios",
            "int",
            "java.util.ArrayList",
            "java.util.ArrayList",
            "systemEvents.GenerateScenarios",
            "ScenariosGenerated",
            "systemEvents.GenerateScenarios",
            "subseaTemplate.agent.SubseaTemplate"};
    private final static java.lang.String[] __reasoningMethods = {
            "body"};
    private final static java.lang.String[] __fsmVariableNames_body = {
            "i",
            "q",
            "wev",
            "wellScenarios"};
    private final static java.lang.String[] __fsmTypes_body = {
            "int",
            "GenerateScenarios",
            "ScenariosGenerated",
            "Scenarios"};
    private final static java.lang.String[] __fsmLocalNames_body = {
            "__local__0_0",
            "__local__0_1",
            "__local__0_2",
            "__local__0_3"};
    //list containing ALL the different well-scenarios.

    static boolean relevant(systemEvents.GenerateScenarios ev)
    {
        return true;
    }
    
    //end body()
//This method generates subseaTemplate-scenarios.
//Input: ArrayList containing Scenarios-objects from all Well-agents.
//Output: Generate an ArrayList containing all the subseaTemplate-scenarios. Pick out three subseaTemplate-scenarios:
//the one having BEST oil/waste-ratio, the one with SECOND BEST oil/waste-ratio producing LESS oil, and
//the one with SECOND BEST oil/waste-ratio producing MORE oil.

    private scenarioStructures.Scenarios generateSubseaTemplateScenarios(java.util.ArrayList wells)
    {
        scenarioStructures.Scenarios subseaTemplateScenarios = new scenarioStructures.Scenarios();
        double[][] bestSubseaTemplateScenario = new double[hoursValidity][2];
        double[][] secondBestScenarioLessOil = {
                {
                    -1.,
                    -1.,
                    -1.}};
        double[][] secondBestScenarioMoreOil = {
                {
                    -1.,
                    -1.,
                    -1.}};
        double[][] oilWasteRatio = new double[hoursValidity][self.getScenariosForEachWell()];
        //run through hour by hour

        for (int i = 0; i < hoursValidity; i++ ) {
            //run through all scenarios (all well-scenarios from all Well-agents)

            for (int x = 0; x < self.getScenariosForEachWell(); x++ ) {
                double accumulatedOil = 0;
                double accumulatedWaste = 0;
                //run through answers from all Well-agents.

                for (int y = 0; y < wells.size(); y++ ) {
                    scenarioStructures.Scenarios wellScenarios = (scenarioStructures.Scenarios) wells.get(y);
                    scenarioStructures.OneWellScenario oneWellScenario = (scenarioStructures.OneWellScenario) wellScenarios.getScenario(x);
                    double double_oil = (double) oneWellScenario.getHourProduction((i + 1),"oil");
                    double double_gas = (double) oneWellScenario.getHourProduction((i + 1),"gas");
                    double double_water = (double) oneWellScenario.getHourProduction((i + 1),"water");
                    double double_sand = (double) oneWellScenario.getHourProduction((i + 1),"sand");
                    accumulatedOil = accumulatedOil + double_oil;
                    accumulatedWaste = accumulatedWaste + (double_gas + double_water + double_sand);
                }
                double double_oilWasteRatio = accumulatedOil / accumulatedWaste;
                //find oil/waste-ratio for specific scenario-id.

                oilWasteRatio[i][x] = double_oilWasteRatio;
                //find the subseaTemplate-scenario with BEST oil/waste-ratio, for specified hour.

                if (double_oilWasteRatio > bestSubseaTemplateScenario[i][1]) {
                    //find which scenario-id at which hour to change in the "best scenario", in order to get the subseaTemplate-scenario with SECOND BEST oil/waste-ratio producing LESS oil, for specified hour.

                    if (x > 0) {
                        secondBestScenarioLessOil[0][0] = i + 1;
                        //which hour to switch well-scenario-id

                        secondBestScenarioLessOil[0][1] = bestSubseaTemplateScenario[i][0];
                        //which well-scenario-id to switch to.

                        secondBestScenarioLessOil[0][2] = bestSubseaTemplateScenario[i][1];
                    }
                    //end if

                    bestSubseaTemplateScenario[i][0] = (double) x;
                    //which well-scenario-id to choose for this hour(hour=row).

                    bestSubseaTemplateScenario[i][1] = double_oilWasteRatio;
                }
                 else 
                    if ((bestSubseaTemplateScenario[i][0] < x) && (secondBestScenarioMoreOil[0][1] < double_oilWasteRatio)) {
                        //find which scenario-id at which hour to change in the "best scenario", in order to get the subseaTemplate-scenario with SECOND BEST oil/waste-ratio producing MORE oil, for specified hour.

                        secondBestScenarioMoreOil[0][0] = i + 1;
                        //which hour to switch well-scenario-id

                        secondBestScenarioMoreOil[0][1] = x;
                        //which well-scenario-id to switch to.

                        secondBestScenarioMoreOil[0][2] = double_oilWasteRatio;
                    }
            }
        }
        scenarioStructures.OneCompositeScenario bestOilWasteRatio = constructBestOilWasteRatioSubseaTemplateScenario(bestSubseaTemplateScenario,wells);
        scenarioStructures.OneCompositeScenario secondBestOilWasteRatioLessOil = constructLessOrMoreOilSubseaTemplateScenario(bestOilWasteRatio,secondBestScenarioLessOil,wells);
        scenarioStructures.OneCompositeScenario secondBestOilWasteRatioMoreOil = constructLessOrMoreOilSubseaTemplateScenario(bestOilWasteRatio,secondBestScenarioMoreOil,wells);
        //add each subseaTemplate-scenarios to a list that contains all generated subseaTemplate-scenarios from this subseaTemplate-Agent.

        subseaTemplateScenarios.addScenarioAndSetScenarioId(bestOilWasteRatio);
        subseaTemplateScenarios.addScenarioAndSetScenarioId(secondBestOilWasteRatioLessOil);
        subseaTemplateScenarios.addScenarioAndSetScenarioId(secondBestOilWasteRatioMoreOil);
        return subseaTemplateScenarios;
    }
    
    //end generateFieldScenarios()
//This method generates the subseatTemplate-scenario objects with best oil/waste ratio.

    private scenarioStructures.OneCompositeScenario constructBestOilWasteRatioSubseaTemplateScenario(double[][] bestOilWasteRatio, java.util.ArrayList wells)
    {
        scenarioStructures.OneCompositeScenario oneSubseaTemplateScenario = new scenarioStructures.OneCompositeScenario();
        //create an empty subseaTemplate-scenario object, to fill with the subseaTemplate-scenario with BEST oil/waste-ratio.
//Fill an empty subseaTemplate-scenario object with the subseaTemplate-scenario
//Run through hour by hour.

        for (int i = 0; i < hoursValidity; i++ ) {
            int wellId = (int) bestOilWasteRatio[i][0];
            //Get the well-scenario from all Well-agents, contained in the scenario to make as a subseaTemplate-scenario object.

            for (int x = 0; x < wells.size(); x++ ) {
                scenarioStructures.Scenarios wellScenarios = (scenarioStructures.Scenarios) wells.get(x);
                scenarioStructures.OneWellScenario oneWellScenario = (scenarioStructures.OneWellScenario) wellScenarios.getScenario(wellId);
                int oil = oneWellScenario.getHourProduction((i + 1),"oil");
                int gas = oneWellScenario.getHourProduction((i + 1),"gas");
                int water = oneWellScenario.getHourProduction((i + 1),"water");
                int sand = oneWellScenario.getHourProduction((i + 1),"sand");
                double double_oil = (double) oil;
                double double_gas = (double) gas;
                double double_water = (double) water;
                double double_sand = (double) sand;
                //Set production for oil, gas, water, sand for the specified hour in this subseaTemplate-scenario.
//This method also updates the total production for the subseaTemplate-scenario.

                oneSubseaTemplateScenario.updateHourFromHourProduction((i + 1),new java.lang.Integer(oil),new java.lang.Integer(gas),new java.lang.Integer(water),new java.lang.Integer(sand));
                //include the well-scenario-object into the subseaTemplate-scenario object.				

                oneSubseaTemplateScenario.buildCompositeScenario(oneWellScenario,(i + 1));
            }
        }
        //end for-loop

        oneSubseaTemplateScenario.setUnitName(self.getName());
        //set the name on the subseaTemplate-Agent that has generated this subseaTemplate-scenario.

        return oneSubseaTemplateScenario;
    }
    
    //end constructSubseaTemplateScenario()
//This method generates subseatTemplate-scenario objects.

    private scenarioStructures.OneCompositeScenario constructLessOrMoreOilSubseaTemplateScenario(scenarioStructures.OneCompositeScenario bestSubseaTemplateScenario, double[][] scenarioLessOrMoreOil, java.util.ArrayList wells)
    {
        scenarioStructures.OneCompositeScenario subseaTemplateScenarioToConvert = cloneOneSubseaTemplateScenario(bestSubseaTemplateScenario);
        int hour = (int) scenarioLessOrMoreOil[0][0];
        int scenarioId = (int) scenarioLessOrMoreOil[0][1];
        subseaTemplateScenarioToConvert.clearProduction(hour);
        //Finding the production for oil, gas, water, and sand, for the specific hour to replace with other well-scenarios in order to produce more or less oil.

        for (int i = 0; i < wells.size(); i++ ) {
            scenarioStructures.Scenarios wellScenarios = (scenarioStructures.Scenarios) wells.get(i);
            scenarioStructures.OneWellScenario oneWellScenario = (scenarioStructures.OneWellScenario) wellScenarios.getScenario(scenarioId);
            subseaTemplateScenarioToConvert.buildCompositeScenario(oneWellScenario,hour);
        }
        //end for-loop		

        subseaTemplateScenarioToConvert.setUnitName(self.getName());
        return subseaTemplateScenarioToConvert;
    }
    
    //end constructSubseaTemplateScenario()
//This method clones a subseaTemplate-scenario.

    private scenarioStructures.OneCompositeScenario cloneOneSubseaTemplateScenario(scenarioStructures.OneCompositeScenario oneSubseaTemplateScenario)
    {
        scenarioStructures.OneCompositeScenario cloneOneSubseaTemplateScenario = new scenarioStructures.OneCompositeScenario(hoursValidity);
        scenarioStructures.OneCompositeScenario finishedClonedScenario = oneSubseaTemplateScenario.cloneScenariosInvolvedHourByHour(cloneOneSubseaTemplateScenario);
        return finishedClonedScenario;
    }
    
    public java.lang.String getDocumentation()
    {
        return "/**\n * FindSubseaTemplateScenarios\n */\n";
    }
    
    public FindSubseaTemplateScenarios()
    {
    }
    
    private FindSubseaTemplateScenarios(aos.jack.jak.task.Task __t, subseaTemplate.plan.FindSubseaTemplateScenarios __env)
    {
        __agent = __env.__agent;
        __ns = __env.__ns;
        __planTask = __t;
        __logic = __t.logic;
        ev = __env.ev;
        ev1 = __env.ev1;
        ev2 = __env.ev2;
        self = (subseaTemplate.agent.SubseaTemplate) __ns.getIF(subseaTemplate.agent.SubseaTemplate.class);
    }
    
    public boolean init_sentinel(aos.jack.jak.agent.NameSpace __a)
    {
        ev = (systemEvents.GenerateScenarios) __a.findEvent("systemEvents.GenerateScenarios");
        if (ev == null) {
            warning("Failed to find GenerateScenarios ev");
            return false;
        }
        ev1 = (systemEvents.ScenariosGenerated) __a.findEvent("systemEvents.ScenariosGenerated");
        if (ev1 == null) {
            warning("Failed to find ScenariosGenerated ev1");
            return false;
        }
        ev2 = (systemEvents.GenerateScenarios) __a.findEvent("systemEvents.GenerateScenarios");
        if (ev2 == null) {
            warning("Failed to find GenerateScenarios ev2");
            return false;
        }
        return true;
    }
    
    public aos.jack.jak.plan.Plan freeze()
    {
        return this;
    }
    
    public aos.jack.jak.plan.Plan unfreeze()
    {
        return this;
    }
    
    public java.lang.Object genObject(int __index)
    {
        switch (__index) {
        }
        aos.jack.jak.core.Jak.error("illegal Object Construction");
        return null;
    }
    
    public aos.jack.jak.cursor.Cursor genCursor(int __index)
        throws java.lang.Exception
    {
        switch (__index) {
        }
        aos.jack.jak.core.Jak.error("illegal Cursor Construction");
        return null;
    }
    
    public aos.jack.jak.fsm.FSM genFSM(int __index)
        throws java.lang.Exception
    {
        switch (__index) {
        }
        aos.jack.jak.core.Jak.error("illegal FSM Construction");
        return null;
    }
    
    public boolean testCondition(int __index)
        throws java.lang.Exception
    {
        switch (__index) {
        }
        aos.jack.jak.core.Jak.error("illegal test Construction");
        return false;
    }
    
    public aos.jack.jak.plan.PlanFSM body()
    {
        return new subseaTemplate.plan.FindSubseaTemplateScenarios.__bodyFSM();
    }
    
    private FindSubseaTemplateScenarios(systemEvents.GenerateScenarios __ev, aos.jack.jak.task.Task __t, subseaTemplate.plan.FindSubseaTemplateScenarios __env)
    {
        this(__t,__env);
        this.ev = __ev;
    }
    
    protected aos.jack.jak.logic.Signature eventSignature(int __log)
    {
        return ev.getSignature(__log);
    }
    
    public java.lang.String handledEvent()
    {
        return "systemEvents.GenerateScenarios";
    }
    
    public boolean __relevant(aos.jack.jak.event.Event __e)
    {
        return __ns.isEnabled() && relevant(((systemEvents.GenerateScenarios) __e));
    }
    
    public aos.jack.jak.plan.Plan createPlan(aos.jack.jak.event.Event __e, aos.jack.jak.task.Task __t)
    {
        if (!(__e instanceof systemEvents.GenerateScenarios)) 
            return null;
        systemEvents.GenerateScenarios __e1 = (systemEvents.GenerateScenarios) __e;
        return new subseaTemplate.plan.FindSubseaTemplateScenarios(__e1,__t,this);
    }
    
    public java.lang.String[] variableNames()
    {
        return __planVariableNames;
    }
    
    public java.lang.String[] variableTypes()
    {
        return __planVariableTypes;
    }
    
    public java.lang.Object getVariable(int n)
    {
        switch (n) {
            case 0: 
            {
                return aos.util.ToObject.box(subseaTemplateScenarios);
            }
            case 1: 
            {
                return aos.util.ToObject.box(hoursValidity);
            }
            case 2: 
            {
                return aos.util.ToObject.box(connectedWells);
            }
            case 3: 
            {
                return aos.util.ToObject.box(generatedWellScenarios);
            }
            case 4: 
            {
                return aos.util.ToObject.box(ev);
            }
            case 5: 
            {
                return aos.util.ToObject.box(ev1);
            }
            case 6: 
            {
                return aos.util.ToObject.box(ev2);
            }
            case 7: 
            {
                return aos.util.ToObject.box(self);
            }
            default: 
            {
                throw new java.lang.IndexOutOfBoundsException("Plan " + this + " does not have variable number " + n);
            }
        }
    }
    
    public java.lang.String[] reasoningMethods()
    {
        return mergeReasoningMethods(__reasoningMethods,super.reasoningMethods());
    }
    
    public aos.jack.jak.cursor.Cursor context()
    {
        try {
            return (((true)?aos.jack.jak.cursor.Cursor.trueCursor:aos.jack.jak.cursor.Cursor.falseCursor));
        }
        catch (java.lang.Exception e) {
            e.printStackTrace();
            return aos.jack.jak.cursor.Cursor.falseCursor;
        }
    }
    
    class __bodyFSM extends aos.jack.jak.plan.PlanFSM implements aos.jack.jak.core.Generator {
        int __local__0_0;
        systemEvents.GenerateScenarios __local__0_1;
        systemEvents.ScenariosGenerated __local__0_2;
        scenarioStructures.Scenarios __local__0_3;
        private int __breakLevel = 0;
        public int run(int __status)
            throws java.lang.Throwable
        {
            do {
                try {
                    if (__tothrow != null) 
                        throw __tothrow;
                    if ((aos.jack.jak.core.Jak.debugging & aos.jack.jak.core.Jak.LOG_PLANS) != 0) 
                        aos.util.logging.LogMsg.log(this,aos.jack.jak.core.Jak.LOG_PLANS,__task + "-FindSubseaTemplateScenarios.body:" + java.lang.Integer.toString(__state));
                    if (__task.nsteps > 0) {
                        __task.nsteps-- ;
                        if (__task.nsteps == 0) 
                            agent.changeFocus();
                    }
                    if (__state < 10) {
                        __status = super.stdrun(subseaTemplate.plan.FindSubseaTemplateScenarios.this,__status);
                        if (__status != CONTINUE || agent.changing_focus) 
                            return __status;
                        continue;
                    }
                    __curstate = __state;
                    switch (__state) {
                        default: 
                        {
                            aos.jack.jak.core.Jak.error("FindSubseaTemplateScenarios.body: Illegal state");
                            return FAILED_STATE;
                        }
                        //* (42) 		hoursValidity = ev.hoursValidity;
                        case 10: 
                        {
                            __breakLevel = 0;
                            __state = 11;
                            hoursValidity = ev.hoursValidity;
                            break;
                        }
                        //* (43)     	connectedWells = self.getConnectedWells();
                        case 11: 
                        {
                            __state = 12;
                            connectedWells = self.getConnectedWells();
                            break;
                        }
                        //* (44)     	generatedWellScenarios = new ArrayList();
                        case 12: 
                        {
                            __state = 13;
                            generatedWellScenarios = new java.util.ArrayList();
                            break;
                        }
                        //* (47)     	for(int i=0; i<connectedWells.size(); i++) {
                        case 13: 
                        {
                            __local__0_0 = 0;
                            __state = 14;
                            break;
                        }
                        //* (47)     	for(int i=0; i<connectedWells.size(); i++) {
                        case 14: 
                        {
                            if (__local__0_0 < connectedWells.size()) 
                                __state = 15;
                             else 
                                __state = 22;
                            break;
                        }
                        //* (48)     		GenerateScenarios q = ev2.generateWellScenarios(hoursValidity);
                        case 15: 
                        {
                            __breakLevel = 4;
                            __local__0_1 = ev2.generateWellScenarios(hoursValidity);
                            __state = 16;
                            break;
                        }
                        //* (49)     		@send( (String)connectedWells.get(i), q );//ask Well-agent for a scenario.
                        case 16: 
                        {
                            __state = 17;
                            agent.send((java.lang.String) connectedWells.get(__local__0_0),__local__0_1);
                            break;
                        }
                        //* (50)        		@waitFor( q.replied() );//wait for the scenario to be generated and returned.
                        case 17: 
                        {
                            __task.push(new aos.jack.jak.fsm.WaitForFSM(getAgent(),__task,this,0));
                            __state = -__state;
                            __subtask_pass = 18;
                            __subtask_fail = 4;
                            return SUBTASK;
                        }
                        //* (51)        		ScenariosGenerated wev = (ScenariosGenerated) q.getReply();//answer containing a well-scenarios from the Well-agent.
                        case 18: 
                        {
                            __local__0_2 = (systemEvents.ScenariosGenerated) __local__0_1.getReply();
                            __state = 19;
                            break;
                        }
                        //* (52)     		Scenarios wellScenarios = wev.scenarios;//list containing ALL the different scenarios for that one specific Well-agent.
                        case 19: 
                        {
                            __local__0_3 = __local__0_2.scenarios;
                            __state = 20;
                            break;
                        }
                        //* (53)     		generatedWellScenarios.add(wellScenarios);//list containing all scenarios from all Well-agents.
                        case 20: 
                        {
                            if (generatedWellScenarios.add(__local__0_3)) 
                                __state = 21;
                             else 
                                throw planfailed;
                            break;
                        }
                        //* (47)     	for(int i=0; i<connectedWells.size(); i++) {
                        case 21: 
                        {
                            __state = 14;
                            __local__0_0++ ;
                            break;
                        }
                        //* (56) 		subseaTemplateScenarios = generateSubseaTemplateScenarios(generatedWellScenarios);//combine all the geographical area-scenarios into field-scenarios.
                        case 22: 
                        {
                            __state = 23;
                            //end for-loop

                            subseaTemplateScenarios = generateSubseaTemplateScenarios(generatedWellScenarios);
                            break;
                        }
                        //* (57) 		self.setSubseaTemplateScenariosList(subseaTemplateScenarios);
                        case 23: 
                        {
                            __state = 24;
                            //combine all the geographical area-scenarios into field-scenarios.

                            self.setSubseaTemplateScenariosList(subseaTemplateScenarios);
                            break;
                        }
                        //* (58) 		@reply(ev, ev1.scenariosGenerated(subseaTemplateScenarios) );//send all the field-scenarios to the OperatorAssistant-agent, in an FieldScenariosGenerated-event.
                        case 24: 
                        {
                            __state = 25;
                            agent.reply(ev,ev1.scenariosGenerated(subseaTemplateScenarios));
                            break;
                        }
                        //* (39)     #reasoning method
                        case 25: 
                        {
                            if (__pending == null) 
                                __state = PASSED_STATE;
                            __tothrow = __pending;
                            break;
                        }
                    }
                }
                catch (java.lang.Throwable e) {
                    handleException(e,__exMap_body);
                }
            }
             while (!agent.changing_focus);
            return CONTINUE;
        }
        
        public java.lang.String methodName()
        {
            return "body";
        }
        
        __bodyFSM()
        {
        }
        
        public java.lang.String stateInfo()
        {
            int n = __curstate;
            java.lang.String file = __tt__body[0];
            java.lang.String method = __tt__body[1];
            if (n < 0) 
                n = -n;
            n -= (10 - 2);
            java.lang.String line = (n < 2)?"??":__tt__body[n];
            return file + ":" + line + " " + method + " [" + __curstate + "]";
        }
        
        public java.lang.Object genObject(int __index)
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal Object Construction");
            return null;
        }
        
        public aos.jack.jak.cursor.Cursor genCursor(int __index)
            throws java.lang.Exception
        {
            switch (__index) {
                case 0: 
                {
                    return (__local__0_1.replied());
                }
            }
            aos.jack.jak.core.Jak.error("illegal Cursor Construction");
            return null;
        }
        
        public aos.jack.jak.fsm.FSM genFSM(int __index)
            throws java.lang.Exception
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal FSM Construction");
            return null;
        }
        
        public boolean testCondition(int __index)
            throws java.lang.Exception
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal test Construction");
            return false;
        }
        
        public aos.jack.jak.plan.Plan getPlan()
        {
            return subseaTemplate.plan.FindSubseaTemplateScenarios.this;
        }
        
        protected aos.jack.jak.fsm.FSM fail()
        {
            return getPlan().fail();
        }
        
        protected aos.jack.jak.fsm.FSM pass()
        {
            return getPlan().pass();
        }
        
        public void enter()
        {
            __trace = agent.trace("subseaTemplate.plan.FindSubseaTemplateScenarios.body");
        }
        
        public java.lang.Object getVariable(int n)
        {
            switch (n) {
                case 0: 
                {
                    return aos.util.ToObject.box(__local__0_0);
                }
                case 1: 
                {
                    return aos.util.ToObject.box(__local__0_1);
                }
                case 2: 
                {
                    return aos.util.ToObject.box(__local__0_2);
                }
                case 3: 
                {
                    return aos.util.ToObject.box(__local__0_3);
                }
                default: 
                {
                    throw new java.lang.IndexOutOfBoundsException("Reasoning Method " + methodName() + " does not have variable number " + n);
                }
            }
        }
        
        public java.lang.String[] variableNames()
        {
            return __fsmVariableNames_body;
        }
        
        public java.lang.String[] variableTypes()
        {
            return __fsmTypes_body;
        }
        
        public java.lang.String[] variableLocalNames()
        {
            return __fsmLocalNames_body;
        }
        
    }
}
