import operatorAssistant.team.*;
import field.team.*;
import geographicalArea.team.*;
import subseaTemplate.team.*;
import well.team.*;
import javax.swing.*;
import production_system.*;

import java.lang.InterruptedException.*;
import java.lang.Thread;


public class Program {

	public static void main(String args[]) throws InterruptedException {
		
		//create one operatorAssistant and one field
		OperatorAssistant operatorAssistant = new OperatorAssistant("operatorAssistant"); 
		while(operatorAssistant.getState()!=2){;}
		Field field = new Field("field"); 
		while(field.getState()!=2){;}
		
		//create links between operatorAssistant and field
		operatorAssistant.setBelongingField(field.getName());
		field.setConnectedToOperatorAssistant(operatorAssistant.getName() );
		
		//create two geographicalArea
		GeographicalArea geographicalArea1 = new GeographicalArea("geographicalArea1"); 
		while(geographicalArea1.getState()!=2){;}
		GeographicalArea geographicalArea2 = new GeographicalArea("geographicalArea2"); 
		while(geographicalArea2.getState()!=2){;}
		
		//create links between field and geographicalArea
		field.addConnectedGeoAreas(geographicalArea1.getName() );
		geographicalArea1.setConnectedToField(field.getName() );
		field.addConnectedGeoAreas(geographicalArea2.getName() );
		geographicalArea2.setConnectedToField(field.getName() );


		//create three wells belonging to a subseaTemplate 1 from geographicalArea 1
		Well well1_ST1_Area1 = new Well("well1_ST1_Area1"); 
		while(well1_ST1_Area1.getState()!=2){;}
		Well well2_ST1_Area1 = new Well("well2_ST1_Area1"); 
		while(well2_ST1_Area1.getState()!=2){;}
		Well well3_ST1_Area1 = new Well("well3_ST1_Area1"); 
		while(well3_ST1_Area1.getState()!=2){;}
		
		//create three wells belonging to a subseaTemplate 2 from geographicalArea 1
		Well well1_ST2_Area1 = new Well("well1_ST2_Area1"); 
		while(well1_ST2_Area1.getState()!=2){;}
		Well well2_ST2_Area1 = new Well("well2_ST2_Area1"); 
		while(well2_ST2_Area1.getState()!=2){;}
		Well well3_ST2_Area1 = new Well("well3_ST2_Area1"); 
		while(well3_ST2_Area1.getState()!=2){;}
		
		//create three wells belonging to a subseaTemplate 1 from geographicalArea 2
		Well well1_ST1_Area2 = new Well("well1_ST1_Area2"); 
		while(well1_ST1_Area2.getState()!=2){;}
		Well well2_ST1_Area2 = new Well("well2_ST1_Area2"); 
		while(well2_ST1_Area2.getState()!=2){;}
		Well well3_ST1_Area2 = new Well("well3_ST1_Area2"); 
		while(well3_ST1_Area2.getState()!=2){;}
		
		//create three wells belonging to a subseaTemplate 2 from geographicalArea 2
		Well well1_ST2_Area2 = new Well("well1_ST2_Area2"); 
		while(well1_ST2_Area2.getState()!=2){;}
		Well well2_ST2_Area2 = new Well("well2_ST2_Area2"); 
		while(well2_ST2_Area2.getState()!=2){;}
		Well well3_ST2_Area2 = new Well("well3_ST2_Area2"); 
		while(well3_ST2_Area2.getState()!=2){;}



		//create four subseaTemplate
		SubseaTemplate subseaTemplate1_Area1 = new SubseaTemplate("subseaTemplate1_Area1"); 
		while(subseaTemplate1_Area1.getState()!=2){;}
		SubseaTemplate subseaTemplate2_Area1 = new SubseaTemplate("subseaTemplate2_Area1"); 
		while(subseaTemplate2_Area1.getState()!=2){;}
		SubseaTemplate subseaTemplate1_Area2 = new SubseaTemplate("subseaTemplate1_Area2"); 
		while(subseaTemplate1_Area2.getState()!=2){;}
		SubseaTemplate subseaTemplate2_Area2 = new SubseaTemplate("subseaTemplate2_Area2"); 
		while(subseaTemplate2_Area2.getState()!=2){;}

		//set the number of scenarios that will be created for each well, when running proactive planning
		subseaTemplate1_Area1.setScenariosForEachWell(2);
		subseaTemplate2_Area1.setScenariosForEachWell(2);
		subseaTemplate1_Area2.setScenariosForEachWell(2);
		subseaTemplate2_Area2.setScenariosForEachWell(2);
		
		//create links between geographicalArea and subseaTemplate
		geographicalArea1.addConnectedSubseaTemplates(subseaTemplate1_Area1.getName() );
		subseaTemplate1_Area1.setConnectedToGeoArea(geographicalArea1.getName() );
		geographicalArea1.addConnectedSubseaTemplates(subseaTemplate2_Area1.getName() );
		subseaTemplate2_Area1.setConnectedToGeoArea(geographicalArea1.getName() );
		geographicalArea2.addConnectedSubseaTemplates(subseaTemplate1_Area2.getName() );
		subseaTemplate1_Area2.setConnectedToGeoArea(geographicalArea2.getName() );
		geographicalArea2.addConnectedSubseaTemplates(subseaTemplate2_Area2.getName() );
		subseaTemplate2_Area2.setConnectedToGeoArea(geographicalArea2.getName() );
					
		//create links between wells and subseaTemplate 1 from geographicalArea 1
		subseaTemplate1_Area1.addConnectedWells(well1_ST1_Area1.getName() );
		well1_ST1_Area1.setConnectedToST(subseaTemplate1_Area1.getName() );
		subseaTemplate1_Area1.addConnectedWells(well2_ST1_Area1.getName() );
		well2_ST1_Area1.setConnectedToST(subseaTemplate1_Area1.getName() );
		subseaTemplate1_Area1.addConnectedWells(well3_ST1_Area1.getName() );
		well3_ST1_Area1.setConnectedToST(subseaTemplate1_Area1.getName() );
		
		//create links between wells and subseaTemplate 2 from geographicalArea 1
		subseaTemplate2_Area1.addConnectedWells(well1_ST2_Area1.getName() );
		well1_ST2_Area1.setConnectedToST(subseaTemplate2_Area1.getName() );
		subseaTemplate2_Area1.addConnectedWells(well2_ST2_Area1.getName() );
		well2_ST2_Area1.setConnectedToST(subseaTemplate2_Area1.getName() );
		subseaTemplate2_Area1.addConnectedWells(well3_ST2_Area1.getName() );
		well3_ST2_Area1.setConnectedToST(subseaTemplate2_Area1.getName() );
		
		//create links between wells and subseaTemplate 1 from geographicalArea 2
		subseaTemplate1_Area2.addConnectedWells(well1_ST1_Area2.getName() );
		well1_ST1_Area2.setConnectedToST(subseaTemplate1_Area2.getName() );
		subseaTemplate1_Area2.addConnectedWells(well2_ST1_Area2.getName() );
		well2_ST1_Area2.setConnectedToST(subseaTemplate1_Area2.getName() );
		subseaTemplate1_Area2.addConnectedWells(well3_ST1_Area2.getName() );
		well3_ST1_Area2.setConnectedToST(subseaTemplate1_Area2.getName() );
		
		//create links between wells and subseaTemplate 2 from geographicalArea 2
		subseaTemplate2_Area2.addConnectedWells(well1_ST2_Area2.getName() );
		well1_ST2_Area2.setConnectedToST(subseaTemplate2_Area2.getName() );
		subseaTemplate2_Area2.addConnectedWells(well2_ST2_Area2.getName() );
		well2_ST2_Area2.setConnectedToST(subseaTemplate2_Area2.getName() );
		subseaTemplate2_Area2.addConnectedWells(well3_ST2_Area2.getName() );
		well3_ST2_Area2.setConnectedToST(subseaTemplate2_Area2.getName() );

		//Set path to already generated well-scenarios to predict proactive planning.
		//This is used to simplify the application and to avoid the calculation of generating well scenarios.
		well1_ST1_Area1.setFilepathPredictionData("C:/MASTER FERDIG/Eclipse_workspace_masteroppgave_VER7/AgentsVersusTeams/src/well/scenariodata/scenarioWell1_ST1_Area1.dat");
		well1_ST1_Area1.setFilepathProductionData("C:/MASTER FERDIG/Eclipse_workspace_masteroppgave_VER7/AgentsVersusTeams/src/well/productiondata/well1_ST1_Area1_ProductionPerHour.dat");
		well1_ST1_Area1.puttingActualProdIntoList();
		well2_ST1_Area1.setFilepathPredictionData("C:/MASTER FERDIG/Eclipse_workspace_masteroppgave_VER7/AgentsVersusTeams/src/well/scenariodata/scenarioWell2_ST1_Area1.dat");
		well2_ST1_Area1.setFilepathProductionData("C:/MASTER FERDIG/Eclipse_workspace_masteroppgave_VER7/AgentsVersusTeams/src/well/productiondata/well2_ST1_Area1_ProductionPerHour.dat");
		well2_ST1_Area1.puttingActualProdIntoList();
		well3_ST1_Area1.setFilepathPredictionData("C:/MASTER FERDIG/Eclipse_workspace_masteroppgave_VER7/AgentsVersusTeams/src/well/scenariodata/scenarioWell3_ST1_Area1.dat");
		well3_ST1_Area1.setFilepathProductionData("C:/MASTER FERDIG/Eclipse_workspace_masteroppgave_VER7/AgentsVersusTeams/src/well/productiondata/well3_ST1_Area1_ProductionPerHour.dat");
		well3_ST1_Area1.puttingActualProdIntoList();
		
		well1_ST2_Area1.setFilepathPredictionData("C:/MASTER FERDIG/Eclipse_workspace_masteroppgave_VER7/AgentsVersusTeams/src/well/scenariodata/scenarioWell1_ST2_Area1.dat");
		well1_ST2_Area1.setFilepathProductionData("C:/MASTER FERDIG/Eclipse_workspace_masteroppgave_VER7/AgentsVersusTeams/src/well/productiondata/well1_ST2_Area1_ProductionPerHour.dat");
		well1_ST2_Area1.puttingActualProdIntoList();
		well2_ST2_Area1.setFilepathPredictionData("C:/MASTER FERDIG/Eclipse_workspace_masteroppgave_VER7/AgentsVersusTeams/src/well/scenariodata/scenarioWell2_ST2_Area1.dat");
		well2_ST2_Area1.setFilepathProductionData("C:/MASTER FERDIG/Eclipse_workspace_masteroppgave_VER7/AgentsVersusTeams/src/well/productiondata/well2_ST2_Area1_ProductionPerHour.dat");
		well2_ST2_Area1.puttingActualProdIntoList();
		well3_ST2_Area1.setFilepathPredictionData("C:/MASTER FERDIG/Eclipse_workspace_masteroppgave_VER7/AgentsVersusTeams/src/well/scenariodata/scenarioWell3_ST2_Area1.dat");
		well3_ST2_Area1.setFilepathProductionData("C:/MASTER FERDIG/Eclipse_workspace_masteroppgave_VER7/AgentsVersusTeams/src/well/productiondata/well3_ST2_Area1_ProductionPerHour.dat");
		well3_ST2_Area1.puttingActualProdIntoList();
		
		well1_ST1_Area2.setFilepathPredictionData("C:/MASTER FERDIG/Eclipse_workspace_masteroppgave_VER7/AgentsVersusTeams/src/well/scenariodata/scenarioWell1_ST1_Area2.dat");
		well1_ST1_Area2.setFilepathProductionData("C:/MASTER FERDIG/Eclipse_workspace_masteroppgave_VER7/AgentsVersusTeams/src/well/productiondata/well1_ST1_Area2_ProductionPerHour.dat");
		well1_ST1_Area2.puttingActualProdIntoList();
		well2_ST1_Area2.setFilepathPredictionData("C:/MASTER FERDIG/Eclipse_workspace_masteroppgave_VER7/AgentsVersusTeams/src/well/scenariodata/scenarioWell2_ST1_Area2.dat");
		well2_ST1_Area2.setFilepathProductionData("C:/MASTER FERDIG/Eclipse_workspace_masteroppgave_VER7/AgentsVersusTeams/src/well/productiondata/well2_ST1_Area2_ProductionPerHour.dat");
		well2_ST1_Area2.puttingActualProdIntoList();
		well3_ST1_Area2.setFilepathPredictionData("C:/MASTER FERDIG/Eclipse_workspace_masteroppgave_VER7/AgentsVersusTeams/src/well/scenariodata/scenarioWell3_ST1_Area2.dat");
		well3_ST1_Area2.setFilepathProductionData("C:/MASTER FERDIG/Eclipse_workspace_masteroppgave_VER7/AgentsVersusTeams/src/well/productiondata/well3_ST1_Area2_ProductionPerHour.dat");
		well3_ST1_Area2.puttingActualProdIntoList();
		
		well1_ST2_Area2.setFilepathPredictionData("C:/MASTER FERDIG/Eclipse_workspace_masteroppgave_VER7/AgentsVersusTeams/src/well/scenariodata/scenarioWell1_ST2_Area2.dat");
		well1_ST2_Area2.setFilepathProductionData("C:/MASTER FERDIG/Eclipse_workspace_masteroppgave_VER7/AgentsVersusTeams/src/well/productiondata/well1_ST2_Area2_ProductionPerHour.dat");
		well1_ST2_Area2.puttingActualProdIntoList();
		well2_ST2_Area2.setFilepathPredictionData("C:/MASTER FERDIG/Eclipse_workspace_masteroppgave_VER7/AgentsVersusTeams/src/well/scenariodata/scenarioWell2_ST2_Area2.dat");
		well2_ST2_Area2.setFilepathProductionData("C:/MASTER FERDIG/Eclipse_workspace_masteroppgave_VER7/AgentsVersusTeams/src/well/productiondata/well2_ST2_Area2_ProductionPerHour.dat");	
		well2_ST2_Area2.puttingActualProdIntoList();
		well3_ST2_Area2.setFilepathPredictionData("C:/MASTER FERDIG/Eclipse_workspace_masteroppgave_VER7/AgentsVersusTeams/src/well/scenariodata/scenarioWell3_ST2_Area2.dat");
		well3_ST2_Area2.setFilepathProductionData("C:/MASTER FERDIG/Eclipse_workspace_masteroppgave_VER7/AgentsVersusTeams/src/well/productiondata/well3_ST2_Area2_ProductionPerHour.dat");
		well3_ST2_Area2.puttingActualProdIntoList();
		
		//create and start GUI
		ChooseProductionTargetFrame chooseProductionTarget = new ChooseProductionTargetFrame();
		//connecting the agent-system to the GUI
		chooseProductionTarget.setOperatorAssistant(operatorAssistant);
		chooseProductionTarget.start();
		
	}//end main()
	
}//end class
